%{

EXT(YLanyG,"goo/boot","<any>");
EXT(YLintG,"goo/boot","<int>");
EXT(YLfloG, "goo/boot", "<flo>");
EXT(YLstrG, "goo/boot", "<str>");
EXT(YLlocG, "goo/boot", "<loc>");
EXT(YLchrG, "goo/boot", "<chr>");
EXT(YLtupG, "goo/boot", "<tup>");

%}

%typemap(out) void {
 // do nothing! it's a void!
}

// Integer stuff (probably could have just typedef'ed a lot of
 // these things together since they use the same code... 
 // but maybe I am forward looking this way...
 // (Truncation, range-enforcing, etc?)

%typemap(in) int {
  $1 = (int)YPiu($input);
}

%typemap(out) int {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) long {
  $1 = (long)YPiu($input);
}

%typemap(out) long {
  $result = (P)YPib((P)((long)$1));
}

%typemap(in) short {
  $1 = (short)YPiu($input);
}

%typemap(out) short {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) char {
  $1 = (char)YPiu($input);
}

%typemap(out) char {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) signed char {
  $1 = (signed char)YPiu($input);
}

%typemap(out) signed char {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) unsigned char {
  $1 = (unsigned char)YPiu($input);
}

%typemap(out) unsigned char {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) unsigned {
  $1 = (unsigned)YPiu($input);
}

%typemap(out) unsigned {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) signed {
  $1 = (signed)YPiu($input);
}

%typemap(out) signed {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) unsigned short {
  $1 = (unsigned short)YPiu($input);
}

%typemap(out) unsigned short {
  $result = (P)YPib((P)((int)$1));
}

%typemap(in) unsigned long {
  $1 = (unsigned long)YPiu($input);
}

%typemap(out) unsigned long {
  $result = (P)YPib((P)((int)$1));
}

// Floating Point

%typemap(in) float {
  $1 = (float)YPfu($input);
}

%typemap(out) float {
  $result = (P)YPfb((P)FLOINT((PFLO)$1));
}

// Double (hack down to float!)

%typemap(in) double {
  $1 = (double)((float)YPfu($input));
}

%typemap(out) double {
  float t = (float)$1;
  $result = (P)YPfb((P)FLOINT((PFLO)t));
}

// Strings

%typemap(in) char * {
  $1 = (char *)YPsu($input);
}

%typemap(out) char * {
  if($1 == NULL)
  {
    $result = (P)YPsb((P)"");
  }
  else
  {
    $result = (P)YPsb((P)$1);
  }
}

// Proto object to proto-object...

%typemap(in) P {
  $1 = $input;
}

%typemap(out) P {
  $result = $1;
}

// Enums (which are ints!)

// treat it like an int
%typemap(in) enum SWIGTYPE {
  $1 = (int)YPiu($input);
}

// treat it like an int
%typemap(out) enum SWIGTYPE {
  $result = (P)YPib((P)$1);
}

// Pointers <-> locatives

%typemap(in) SWIGTYPE * {
  $1 = ($1_type)YPlu($input);
}

%typemap(out) SWIGTYPE * {
  $result = (P)YPlb((P)$1);
}

%{

extern P YOisaQ(P, P);

static P multi_argout(P outsofar, P curout)
{
  P newvec;
  int masked;
  DEFCREGS();

  if(outsofar == NULL)
    return curout;

  // it's a vector if it's an address and the type matches
   // (sadly, strings can be addresses too...)
  
  masked = ((((int)outsofar)&tag_mask) == adr_tag);
  if(masked &&
	(YOisaQ(outsofar, VARREF(YLtupG)) != YPfalse))
  {
    // VECTOR already!
    int len, i;

    len = (int)YPtlen(outsofar);

    newvec = YPPtfab((P)(len + 1), (P)0);

    for(i=0; i < len; i++)
    {
      YPtelt_setter(YPtelt(outsofar, i), newvec, i);
    }

    YPtelt_setter(curout, newvec, i);
  }
  else // not a vector. so stick the current guy and us in!
  {
    newvec = YPPtfab((P)2, (P)0);

    YPtelt_setter(outsofar, newvec, 0);
    YPtelt_setter(curout, newvec, 1);
  }

  return newvec;
}

%}

%typemap(arginit) int *OUTPUT(int actualint) {
  $1 = &actualint;
}

%typemap(ignore) int *OUTPUT {
  // ignoring int *OUTPUT for $input $1 $result $arg $argnum
}

%typemap(argout) int *OUTPUT {
  P val = (P)YPib((P)*$1);
  $result = multi_argout($result, val);
}

%typemap(argout) float *OUTPUT {
  P val = (float)YPfu(*$input);
  $result = multi_argout($result, val);
}

%typemap(argout) char *OUTPUT {
  P val = (P)YPsb((P)$1);
  $result = multi_argout($result, val);
}

%typemap(argout) SWIGTYPE *OUTPUT {
  P val = (P)YPlb((P)$1);
  $result = multi_argout($result, val);
}

%typemap(out) SWIGTYPE [] {
  // SWIGTYPE []
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    YPtelt_setter((P)YPlb((P)$opt_ref$1[i]), $result, i);
  }
}

%typemap(out) int [ANY] {
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    YPtelt_setter((P)YPib((P)$1[i]), $result, i);
  }
}

%typemap(out) long [ANY] {
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    YPtelt_setter((P)YPib((P)$1[i]), $result, i);
  }
}

%typemap(out) short [ANY] {
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    YPtelt_setter((P)YPib((P)((int)$1[i])), $result, i);
  }
}

%typemap(out) float [ANY] {
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    YPtelt_setter((P)YPfb((P)FLOINT((PFLO)$1[i])), $result, i);
  }
}

%typemap(out) char [ANY] {
  $result = YPPsfab((P)strlen($1), (P)0);
}

%typemap(out) char * [ANY] {
  int i;

  $result = YPPtfab((P)$1_dim0, (P)0);
  for(i=0; i < $1_dim0; i++)
  {
    if($1[i]) 
    {
      P pstr = YPPsfab((P)strlen($1[i]), (P)0);
      YPtelt_setter(pstr, $result, i);
    }
  }
}

//
// More advanced stuff
//

// --- 
// Arrays of strings
%typemap(in) char *[] {
  int i, len;

  len = (int)YPtlen($input);
  $1 = (char **)malloc((len + 1) * sizeof(char *));
  
  for(i=0; i < len; i++)
  {
    $1[i] = (char *)YPsu(YPtelt($input, i));
  }

  $1[i] = NULL;
}

%typemap(freearg) char*[] {
  if($1) free($1);
}

// ---
%typemap(in) int [ANY] {
  int i;
  $1 = (int *)malloc($1_dim0 * sizeof(int));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (int)YPiu(YPtelt($input, i));
  }
}

%typemap(freearg) int [ANY] {
  if($1) free($1);
}

%typemap(in) long [ANY] {
  int i;
  $1 = (long *)malloc($1_dim0 * sizeof(long));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (long)YPiu(YPtelt($input, i));
  }
}

%typemap(freearg) long [ANY] {
  if($1) free($1);
}

%typemap(in) short [ANY] {
  int i;
  $1 = (short *)malloc($1_dim0 * sizeof(short));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (short)YPiu(YPtelt($input, i));
  }
}

%typemap(freearg) short [ANY] {
  if($1) free($1);
}

%typemap(in) float [ANY] {
  int i;
  $1 = (float *)malloc($1_dim0 * sizeof(float));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (float)YPfu(YPtelt($input, i));
  }
}

%typemap(freearg) float [ANY] {
  if($1) free($1);
}

%typemap(in) double [ANY] {
  int i;
  $1 = (double *)malloc($1_dim0 * sizeof(double));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (double)((float)YPfu(YPtelt($input, i)));
  }
}

%typemap(freearg) double [ANY] {
  if($1) free($1);
}


%typemap(in) char [ANY] {
  int i;
  $1 = (char *)malloc($1_dim0 * sizeof(char));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (char)YPcu(YPtelt($input, i));
  }
}

%typemap(freearg) char [ANY] {
  if($1) free($1);
}

%typemap(in) char * [ANY] {
  int i, len;

  len = (int)YPtlen($input);  

  $1 = (char **)malloc((len + 1) * sizeof(char *));
 
  for(i=0; i < len; i++)
  {
    $1[i] = (char *)YPsu(YPtelt($input, i));
  }

  $1[i] = NULL;
}

%typemap(freearg) char * [ANY] {
  if($1) free($1);
}


// ---
%typemap(in, doc="tup") (int veclen, gfloat vector[]) {
  int i;

  $1 = (int)YPtlen($input);
  $2 = (float *)malloc($1 * sizeof(float));
  
  for(i=0; i < $1; i++)
  {
    $2[i] = (float)YPfu(YPtelt($input, i));
  }
}

// cleanup
%typemap(freearg) (int veclen, gfloat vector[]) {
  if($2) free($2);
}

%typemap(in, doc="tup") (char vec[], int veclen) {
  int i;

  $2 = (int)YPtlen($input);
  $1 = (char *)malloc($2 * sizeof(char));

  for(i=0; i < $2; i++)
  {
    $1[i] = (char)YPiu(YPtelt($input, i));
  }
}

%typemap(freearg) (char vec[], int veclen) {
  if($1) free($1);
}

// Array of foreign pointer type
%typemap(in, doc="tup") (void vec[], int veclen) {
  int i;

  $2 = (int)YPtlen($input);
  $1 = ($1_type)malloc($2 * sizeof($*1_type));

  for(i=0; i < $2; i++)
  {
    $1[i] = *(($1_type)YPlu(YPtelt($input, i)));
  }
}

%typemap(freearg) (void vec[], int veclen) {
  if($1) free($1);
}

// ----- DOOT

%typemap(memberin) float [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) double [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) int [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) short [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) long [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) char [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) char * [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}
