// --- stupid stuff ---

%typemap(out) void {
  // do nothing! it's a void!
}

//    ______
// <<<< IN >>>>
//    \____/

// scheme48 object to scheme48 object
%typemap(in) s48_value {
  $1 = $input;
}

%typemap(in) short {
  $1 = (short)s48_extract_integer($input);
}

%typemap(in) int {
  $1 = (int)s48_extract_integer($input);
}

%typemap(in) long {
  $1 = s48_extract_integer($input);
}

%typemap(in) unsigned {
  $1 = (unsigned)s48_extract_integer($input);
}

%typemap(in) signed {
  $1 = (signed)s48_extract_integer($input);
}

%typemap(in) unsigned short {
  $1 = (unsigned short)s48_extract_integer($input);
}

%typemap(in) unsigned long {
  $1 = (unsigned long)s48_extract_integer($input);
}

%typemap(in) float {
  $1 = (float)s48_extract_double($input);
}

%typemap(in) double {
  $1 = s48_extract_double($input);
}

%typemap(in) signed char {
  $1 = s48_extract_char((char) $input);
}

%typemap(in) unsigned char {
  $1 = s48_extract_char((char) $input);
}

%typemap(in) char {
  $1 = s48_extract_char($input);
}

%typemap(in) char * {
  $1 = s48_extract_string($input);
}

%typemap(in) bool {
  $1 = S48_EXTRACT_BOOLEAN($input);
}

//    _______
// <<<< OUT >>>>
//    \_____/

%typemap(out) short {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) int {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) long {
  $result = s48_enter_integer($1);
}

%typemap(out) unsigned {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) signed {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) unsigned short {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) unsigned long {
  $result = s48_enter_integer((long)$1);
}

%typemap(out) float {
  $result = s48_enter_double((double)$1);
}

%typemap(out) double {
  $result = s48_enter_double($1);
}

%typemap(out) signed char {
  $result = s48_enter_char((char)$1);
}

%typemap(out) unsigned char {
  $result = s48_enter_char((char)$1);
}

%typemap(out) char {
  $result = s48_enter_char($1);
}

// this could very well leak memory, but hopefully someone
 // thought about that when they wrote their func...
%typemap(out) char * {
  $result = s48_enter_string($1);
}

%typemap(out) bool {
  $result = S48_ENTER_BOOLEAN($1);
}

// ****
//  ****
//   **** Base magic, a la SWIGTYPE
//    ****
//     ****

// --- Enums ---

%typemap(in) enum SWIGTYPE {
  $1 = s48_extract_integer($input);
}

%typemap(out) enum SWIGTYPE {
  $result = s48_enter_integer($1);
}

// --- Pointers -> Sexy Byte Vectors ---
%typemap(in) SWIGTYPE * {
  $1 = ($1_type)(s48_extract_fixnum($input) << 2);
}

%typemap(out) SWIGTYPE * {
  $result = s48_enter_fixnum(((long)$1) >> 2);
}

// --- Multi-argument support ---

// currently todo: protect outdude from GC-death

%{

#define multi_argout(outdude, indude) \
{ \
  argsout++; \
\
  if(argsout == 1) \
    outdude = indude; \
  else if(argsout == 2) \
  { \
    s48_value vec = s48_make_vector(2, s48_enter_fixnum(0)); \
    S48_VECTOR_SET(vec, 0, outdude); \
    S48_VECTOR_SET(vec, 1, indude); \
    outdude = vec; \
  } \
  else \
  { \
    int i; \
    s48_value vec = s48_make_vector(argsout, s48_enter_fixnum(0)); \
    for(i=0; i < (argsout - 1); i++) \
    { \
      S48_VECTOR_SET(vec, i, S48_VECTOR_REF(outdude, i)); \
    } \
    S48_VECTOR_SET(vec, argsout - 1, indude); \
    outdude = vec; \
  } \
}

%}

%typemap(arginit) int *OUTPUT(int actualint) {
  $1 = ($1_type)&actualint;
}

%typemap(ignore) int *OUTPUT {
  // ignoring int *OUTPUT for $input $1 $result $arg $argnum
}

%typemap(ignore) long *OUTPUT {
  // ignoring long *OUTPUT
}

%typemap(ignore) float *OUTPUT {
  // ignoring float *OUTPUT
}

%typemap(ignore) double *OUTPUT {
  // ignoring double *OUTPUT
}

%typemap(ignore) char *OUTPUT {
  // ignoring char *OUTPUT
}

%typemap(ignore) bool *OUTPUT {
  // ignoring bool *OUTPUT
}

%typemap(ignore) SWIGTYPE *OUTPUT {
  // ignoring SWIGTYPE *OUTPUT
}

%typemap(argout) int *OUTPUT {
  s48_value v = s48_enter_integer((long)$1);
  multi_argout($result, v);
}

%typemap(ignore) long *OUTPUT {
  s48_value v = s48_enter_integer($1);
  multi_argout($result, v);
}

%typemap(argout) float *OUTPUT {
  s48_value v = s48_enter_double((double)$1);
  multi_argout($result, v);
}

%typemap(argout) double *OUTPUT {
  s48_value v = s48_enter_double($1);
  multi_argout($result, v);
}

// this could very well leak memory, but hopefully someone
 // thought about that when they wrote their func...
%typemap(argout) char *OUTPUT {
  s48_value v = s48_enter_string($1);
  multi_argout($result, v);
}

%typemap(argout) bool *OUTPUT {
  s48_value v = S48_ENTER_BOOLEAN($1);
  multi_argout($result, v);
}

%typemap(argout) SWIGTYPE *OUTPUT {
  s48_value v = s48_enter_fixnum(((long)$1) >> 2);
  multi_argout($result, v);
}

// hopefully I've applied an $opt_ref patch to the scheme48 module
 // by the time this typemap is actually used...
%typemap(out) SWIGTYPE [] {
  int i;

  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_fixnum(((long)$opt_ref$1[i]) >> 2));
  }
}

%typemap(in) int [ANY] {
  int i;
  $1 = (int *)malloc($1_dim0 * sizeof(int));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (int)s48_extract_integer(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) int [ANY] {
  if($1) free($1);
}

%typemap(out) int [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_integer((long)$1[i]));
  }
}

%typemap(in) long [ANY] {
  int i;
  $1 = (long *)malloc($1_dim0 * sizeof(long));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = s48_extract_integer(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) long [ANY] {
  if($1) free($1);
}

%typemap(out) long [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_integer($1[i]));
  }
}

%typemap(in) short [ANY] {
  int i;
  $1 = (short *)malloc($1_dim0 * sizeof(short));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (short)s48_extract_integer(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) short [ANY] {
  if($1) free($1);
}

%typemap(out) short [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_integer((long)$1[i]));
  }
}

%typemap(in) float [ANY] {
  int i;
  $1 = (float *)malloc($1_dim0 * sizeof(float));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (float)s48_extract_double(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) float [ANY] {
  if($1) free($1);
}

%typemap(out) float [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_double((double)$1[i]));
  }
}

%typemap(in) double [ANY] {
  int i;
  $1 = (double *)malloc($1_dim0 * sizeof(double));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = (float)s48_extract_double(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) double [ANY] {
  if($1) free($1);
}

%typemap(out) double [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_double($1[i]));
  }
}

%typemap(in) char [ANY] {
  int i;
  $1 = (char *)malloc($1_dim0 * sizeof(char));
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = s48_extract_char(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) char [ANY] {
  if($1) free($1);
}

%typemap(out) char [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_char($1[i]));
  }
}

%typemap(out) char [ANY] {
  $result = s48_enter_string($1);
}

// --- Advanced stuff

%typemap(in) char * [ANY] {
  int i, len;
  
  len = S48_VECTOR_LENGTH($input);

  $1 = (char **)malloc((len + 1) * sizeof(char *));
 
  for(i=0; i < len; i++)
  {
    $1[i] = s48_extract_string(S48_VECTOR_REF($input, i));
  }

  $1[i] = NULL;
}

%typemap(freearg) char * [ANY] {
  if($1) free($1);
}

%typemap(out) char * [ANY] {
  int i;
  $result = s48_make_vector($1_dim0, s48_enter_fixnum(0));
  for(i=0; i < $1_dim0; i++)
  {
    S48_VECTOR_SET($result, i, s48_enter_string($1[i]));
  }
}

// --- Arrays of Floats

// create
%typemap(in) (int veclen, float vector[]) {
  int i;

  $1 = S48_VECTOR_LENGTH($input);
  $2 = (float *)malloc($1 * sizeof(float));

  for(i=0; i < $1; i++)
  {
    $2[i] = (float)s48_extract_double(S48_VECTOR_REF($input, i));
  }
}

// cleanup
%typemap(freearg) (int veclen, float vector[]) {
  if($2) free($2);
}

// --- More array stuff
%typemap(in) (char vec[], int veclen) {
  int i;

  $2 = S48_VECTOR_LENGTH($input);
  $1 = (char *)malloc($2 * sizeof(char));

  for(i=0; i < $2; i++)
  {
    $1[i] = (char)s48_extract_integer(S48_VECTOR_REF($input, i));
  }
}

%typemap(freearg) (char vec[], int veclen) {
  if($1) free($1);
}

// --- Member array grabbers...

// these seem to rely on (in) already having been defined...
 // (trial-and-error led to having both the (in) and (memberin)
 // with the memberin being dumb
// er, just read the docs, and that apparently *IS* what these dudes are 
 // supposed to do.  go figure.  probably should re-do the goo ones then, eh?


%typemap(memberin) float [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) double [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) int [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) short [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) long [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) char [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}

%typemap(memberin) char * [ANY] {
  int i;
  for(i=0; i < $1_dim0; i++)
  {
    $1[i] = $input[i];
  }
}
