/*****************************************************************************
 * Simplified Wrapper and Interface Generator  (SWIG)
 *
 * Author : David Beazley
 *
 * Department of Computer Science
 * University of Chicago
 * 1100 E 58th Street
 * Chicago, IL  60637
 * beazley@cs.uchicago.edu
 *
 * Please read the file LICENSE for the copyright and terms by which SWIG
 * can be used and distributed.
 *****************************************************************************/

#include "swig.h"

class SCHEME48 : public Language
{
private:
  char   *prefix;
  char   *module;
  char   *package;
  File  *procdoc;
  File  *scmstub;
  String *scmtext;
  enum {
    SCHEME48_1_4,
    PLAIN,
    TEXINFO
  } docformat;
  int	 emit_setters;
  int    struct_member;
  String *before_return;
  String *pragma_name;
  String *exported_symbols;
  void   emit_linkage(char *module_name);
public :
  SCHEME48 ();
  virtual void main (int, char *argv[]);
  virtual int top(Node *);
  virtual int functionWrapper(Node *);
  virtual int constantWrapper(Node *);
  virtual int variableWrapper(Node *);
  virtual int membervariableHandler(Node *);

  void pragma(char *lang, char *cmd, char *value);
  int  validIdentifier(String *s);
};

/* scheme48.h ends here */
