/*******************************************************************************

 * irCommTest.c

 * target: PushpinV3

 *

 * Josh Lifton

 * lifton@media.mit.edu

 * MIT Media Lab

 * Copyright 2001 all rights reserved.

 *

 * Last modified 11DEC2001 by lifton.

 *

 *******************************************************************************/



#include <c8051F000.h>

#include <PushpinFunctions.h>

#include <PushpinHardwareV3.h>



unsigned char bdata serialChar;

sbit byteHalfSent = serialChar ^ 7;

sbit hasMoreBytes = serialChar ^ 6;

sbit isChannelSelected = serialChar ^ 5;

unsigned char testByte;

unsigned int counter;

unsigned char xdata receiveBuffer[2048];



#include <PushpinUtil.c>

#include <IRSerial.c>







void main() {

	

	configureWatchdogTimer();

	enableExternalClock();

	initializeVariables();

	configurePorts();

	enableIRSerial();

	enableInterrupts();

	flash(3,1000);



	testByte = 0x0f;



//  Uncomment here to transmit repeatedly.

//	EIE2 &= ~(0x3C);		// Disable external interrupts IE[4-7].

//	transmit();				// Transmitting testByte.

	

//  Uncomment here to only receive.

	receive();				// Listen for data.



	while (1) {

	}

}



void channel0Interrupt(void) interrupt 19 {

//	if ((!isChannelSelected) && REN) {

//		setReceiveChannel(0);

//		isChannelSelected = 1;

//		flash(1,0xffff);

//	}

//	setReceiveChannel(0);

//	isChannelSelected = 1;

	flash(1,0xffff);

//	EIE2 &= ~(0x3C);		// Disable IE[4-7].

	PRT1IF &= 0x0F;			// Clear interrupt flags.

}



void channel1Interrupt(void) interrupt 18 {

//	if ((!isChannelSelected) && REN) {

//		setReceiveChannel(1);

//		isChannelSelected = 1;

//		flash(1,0xffff);

//	}

//	setReceiveChannel(1);

//	isChannelSelected = 1;

	flash(1,0xffff);

//	EIE2 &= ~(0x3C);		// Disable IE[4-7].

	PRT1IF &= 0x0F;			// Clear interrupt flags.

}



void channel2Interrupt(void) interrupt 17 {

//	if ((!isChannelSelected) && REN) {

//		setReceiveChannel(2);

//		isChannelSelected = 1;

//		flash(1,0xffff);

//	}

//	setReceiveChannel(2);

//	isChannelSelected = 1;

	flash(1,0xffff);

//	EIE2 &= ~(0x3C);		// Disable IE[4-7].

	PRT1IF &= 0x0F;			// Clear interrupt flags.

}	



void channel3Interrupt(void) interrupt 16 {

//	if ((!isChannelSelected) && REN) {

//		setReceiveChannel(3);

//		isChannelSelected = 1;

//		flash(1,0xffff);

//	}

//	setReceiveChannel(3);

//	isChannelSelected = 1;

	flash(1,0xffff);

//	EIE2 &= ~(0x3C);		// Disable IE[4-7].

	PRT1IF &= 0x0F;			// Clear interrupt flags.

}